%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Load = Read_Config(Config_File_Directory, Config_File_Name)

global ErrCode;

global software_version;

Load = [];

% Открытие файла
File_Path = [Config_File_Directory '\' Config_File_Name '.alcfg'];

Fin = fopen(File_Path, 'r');

if (Fin < 0)
    fprintf (1, '\nОшибка функции Read_Config: не удалось открыть файл %s !\n', File_Path);
    ErrCode = -1;
    return;
end

% Создание структуры с настройками нагружения
Load.Basic_Plane.Definition = [];
Load.Basic_Plane.Z0 = [];
Load.Basic_Plane.Z1 = [];
Load.Basic_Plane.D1 = [];
Load.Basic_Plane.D2 = [];
Load.Basic_Plane.D3 = [];
Load.Basic_Plane.Equation = [];

Load.Chord_Surface.A1 = [];
Load.Chord_Surface.A2 = [];
Load.Chord_Surface.A3 = [];
Load.Chord_Surface.A4 = [];
Load.Chord_Surface.A1_projected = [];
Load.Chord_Surface.A2_projected = [];
Load.Chord_Surface.A3_projected = [];
Load.Chord_Surface.A4_projected = [];

Load.Pn = [];
Load.Vector = [];

Load.Span_Load.Law = [];

Load.Span_Load.Trapezoid_Zd_Type = [];
Load.Span_Load.Trapezoid_Zd_Value = [];
Load.Span_Load.Trapezoid_Zd_Location = [];

Load.Span_Load.Load_Diagram_File_Name = [];
Load.Span_Load.Load_Diagram_Data = [];
Load.Span_Load.Load_Diagram_Initial_Data = [];

Load.Chord_Pressure.Law = [];

Load.Chord_Pressure.Trapezoid_Xd_Type = [];
Load.Chord_Pressure.Trapezoid_Xd_Value = [];
Load.Chord_Pressure.Trapezoid_Xd_Location = [];
Load.Chord_Pressure.Trapezoid_Xd_Distr_File_Name = [];
Load.Chord_Pressure.Trapezoid_Xd_Distr_Data = [];
Load.Chord_Pressure.Trapezoid_Xd_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_p2_p1_Type = [];
Load.Chord_Pressure.Model_X_p2_p1_Value = [];
Load.Chord_Pressure.Model_X_p2_p1_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_p2_p1_Distr_Data = [];
Load.Chord_Pressure.Model_X_p2_p1_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_p3_p1_Type = [];
Load.Chord_Pressure.Model_X_p3_p1_Value = [];
Load.Chord_Pressure.Model_X_p3_p1_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_p3_p1_Distr_Data = [];
Load.Chord_Pressure.Model_X_p3_p1_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_p4_p1_Type = [];
Load.Chord_Pressure.Model_X_p4_p1_Value = [];
Load.Chord_Pressure.Model_X_p4_p1_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_p4_p1_Distr_Data = [];
Load.Chord_Pressure.Model_X_p4_p1_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_f_Type = [];
Load.Chord_Pressure.Model_X_f_Value = [];
Load.Chord_Pressure.Model_X_f_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_f_Distr_Data = [];
Load.Chord_Pressure.Model_X_f_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_f1_Type = [];
Load.Chord_Pressure.Model_X_f1_Value = [];
Load.Chord_Pressure.Model_X_f1_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_f1_Distr_Data = [];
Load.Chord_Pressure.Model_X_f1_Distr_Initial_Data = [];

Load.Chord_Pressure.Model_X_f2_Type = [];
Load.Chord_Pressure.Model_X_f2_Value = [];
Load.Chord_Pressure.Model_X_f2_Distr_File_Name = [];
Load.Chord_Pressure.Model_X_f2_Distr_Data = [];
Load.Chord_Pressure.Model_X_f2_Distr_Initial_Data = [];

Load.Chord_Pressure.User_Model_File_Name = [];
Load.Chord_Pressure.User_Model_Data = [];
Load.Chord_Pressure.User_Model_Initial_Data = [];

Load.Extrapolation.Span_Load_0 = [];
Load.Extrapolation.Span_Load_1 = [];
Load.Extrapolation.Chord_Pressure_0 = [];
Load.Extrapolation.Chord_Pressure_1 = [];
Load.Extrapolation.User_Model_0 = [];
Load.Extrapolation.User_Model_1 = [];
Load.Extrapolation.Trapezoid_Xd_0 = [];
Load.Extrapolation.Trapezoid_Xd_1 = [];
Load.Extrapolation.Model_X_p2_p1_0 = [];
Load.Extrapolation.Model_X_p2_p1_1 = [];
Load.Extrapolation.Model_X_p3_p1_0 = [];
Load.Extrapolation.Model_X_p3_p1_1 = [];
Load.Extrapolation.Model_X_p4_p1_0 = [];
Load.Extrapolation.Model_X_p4_p1_1 = [];
Load.Extrapolation.Model_X_f_0 = [];
Load.Extrapolation.Model_X_f_1 = [];
Load.Extrapolation.Model_X_f1_0 = [];
Load.Extrapolation.Model_X_f1_1 = [];
Load.Extrapolation.Model_X_f2_0 = [];
Load.Extrapolation.Model_X_f2_1 = [];

Load.Summation_Point = [];

Load.Coord_Origin = [];
Load.Point_On_Axis_3 = [];
Load.Point_On_Plane_13 = [];

Load.Correction_Coefficient = [];

Load.Distributed_Load_Mode = [];
Load.Vector_Field_Component = [];
Load.Field_Name = [];

Load.Precomputed_Data = [];

% Проверка версии ПО
Config_Software_Version = [];

while (~feof(Fin))
    
    string = strtrim(fgets(Fin));
    
    if (isempty(string))
        continue;
    end
    
    if (string(1) == '#')
        continue;
    end
    
    temp_cell_array = strsplit(string, {' ', '\t', '='});
    
    if (isempty(temp_cell_array{1}) || isempty(temp_cell_array{size(temp_cell_array,2)}))
        fprintf (1, '\nОшибка: нарушен формат конфигурационного файла в строке [%s] !\n', string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    if (strcmpi(temp_cell_array{1}, 'SOFTWARE_VERSION'))
        
        N_Data_Items = 1;
        
        if (~isempty(Config_Software_Version))
            fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SOFTWARE_VERSION !\n');
            ErrCode = -1;
            fclose(Fin);
            return;
        end
        
        Check_Cell_Array(temp_cell_array, string, N_Data_Items);

        if (ErrCode < 0)
            fclose(Fin);
            return;
        end
        
        Config_Software_Version = temp_cell_array{2};
        
    end
    
end

if (isempty(Config_Software_Version))
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует команда SOFTWARE_VERSION !\n');
    ErrCode = -1;
    fclose(Fin);
    return;
end

switch Config_Software_Version
    
    case '2.0'
        % Поддерживаемая версия
        
    otherwise
        
        fprintf (1, '\nОшибка: указанный конфигурационный файл не поддерживается в текущей версии программы (%s), так как был создан в программе более поздней версии %s !\n', software_version, Config_Software_Version);
        fprintf (1, 'Обновите программу Aero Load до актуальной версии.\n');
        ErrCode = -1;
        fclose(Fin);
        return;
        
end

% Переход в начало файла
fseek(Fin, 0, 'bof');

% Чтение настроек
while (~feof(Fin))
    
    string = strtrim(fgets(Fin));
    
    if (isempty(string))
        continue;
    end
    
    if (string(1) == '#')
        continue;
    end
    
    temp_cell_array = strsplit(string, {' ', '\t', '='});
    
    if (isempty(temp_cell_array{1}) || isempty(temp_cell_array{size(temp_cell_array,2)}))
        fprintf (1, '\nОшибка: нарушен формат конфигурационного файла в строке [%s] !\n', string);
        ErrCode = -1;
        fclose(Fin);
        return;
    end
    
    switch upper(temp_cell_array{1})
        
        case 'SOFTWARE_VERSION'
            
            % Ничего не делаем
        
        case 'BASIC_PLANE_DEFINITION'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Basic_Plane.Definition))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды BASIC_PLANE_DEFINITION !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.Definition = temp_cell_array{2};
            
        case 'Z0'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Basic_Plane.Z0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды Z0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.Z0 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'Z1'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Basic_Plane.Z1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды Z1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.Z1 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'D1'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Basic_Plane.D1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды D1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.D1 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'D2'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Basic_Plane.D2))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды D2 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.D2 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'D3'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Basic_Plane.D3))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды D3 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Basic_Plane.D3 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'A1'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Chord_Surface.A1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды A1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Surface.A1 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'A2'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Chord_Surface.A2))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды A2 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Surface.A2 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'A3'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Chord_Surface.A3))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды A3 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Surface.A3 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'A4'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Chord_Surface.A4))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды A4 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Surface.A4 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'PN'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Pn))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды PN !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Pn = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'SPAN_LOAD_LAW'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Span_Load.Law))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_LOAD_LAW !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Span_Load.Law = temp_cell_array{2};
            
        case 'SPAN_TRAPEZOID_ZD_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Span_Load.Trapezoid_Zd_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_TRAPEZOID_ZD_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Span_Load.Trapezoid_Zd_Type = temp_cell_array{2};
            
        case 'SPAN_TRAPEZOID_ZD_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Span_Load.Trapezoid_Zd_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_TRAPEZOID_ZD_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Span_Load.Trapezoid_Zd_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'SPAN_TRAPEZOID_ZD_LOCATION'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Span_Load.Trapezoid_Zd_Location))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_TRAPEZOID_ZD_LOCATION !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Span_Load.Trapezoid_Zd_Location = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'LOAD_DIAGRAM'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Span_Load.Load_Diagram_Data = tmp;
            
        case 'CHORD_PRESSURE_LAW'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Law))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_PRESSURE_LAW !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Law = temp_cell_array{2};
            
        case 'CHORD_TRAPEZOID_XD_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Trapezoid_Xd_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_TRAPEZOID_XD_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Trapezoid_Xd_Type = temp_cell_array{2};
            
        case 'CHORD_TRAPEZOID_XD_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Trapezoid_Xd_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_TRAPEZOID_XD_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Trapezoid_Xd_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_TRAPEZOID_XD_LOCATION'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Chord_Pressure.Trapezoid_Xd_Location))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_TRAPEZOID_XD_LOCATION !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Trapezoid_Xd_Location = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_TRAPEZOID_XD_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Trapezoid_Xd_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_P2_P1_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p2_p1_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P2_P1_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p2_p1_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_P2_P1_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p2_p1_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P2_P1_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p2_p1_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_P2_P1_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p2_p1_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_P3_P1_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p3_p1_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P3_P1_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p3_p1_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_P3_P1_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p3_p1_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P3_P1_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p3_p1_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_P3_P1_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p3_p1_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_P4_P1_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p4_p1_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P4_P1_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p4_p1_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_P4_P1_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_p4_p1_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_P4_P1_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p4_p1_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_P4_P1_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_p4_p1_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_F_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_F_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_F_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_F1_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f1_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F1_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f1_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_F1_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f1_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F1_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f1_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_F1_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f1_Distr_Data = tmp;
            
        case 'CHORD_MODEL_X_F2_TYPE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f2_Type))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F2_TYPE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f2_Type = temp_cell_array{2};
            
        case 'CHORD_MODEL_X_F2_VALUE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Chord_Pressure.Model_X_f2_Value))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_MODEL_X_F2_VALUE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f2_Value = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CHORD_MODEL_X_F2_DISTRIBUTION'
            
            [tmp, Fin] = Read_CFG_Distribution(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.Model_X_f2_Distr_Data = tmp;
            
        case 'CHORD_USER_MODEL'
            
            [tmp, Fin] = Read_CFG_User_Model(Fin);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Chord_Pressure.User_Model_Data = tmp;
            
        case 'SPAN_LOAD_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Span_Load_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_LOAD_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Span_Load_0 = temp_cell_array{2};
            
        case 'SPAN_LOAD_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Span_Load_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SPAN_LOAD_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Span_Load_1 = temp_cell_array{2};
            
        case 'CHORD_PRESSURE_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Chord_Pressure_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_PRESSURE_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Chord_Pressure_0 = temp_cell_array{2};
            
        case 'CHORD_PRESSURE_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Chord_Pressure_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CHORD_PRESSURE_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Chord_Pressure_1 = temp_cell_array{2};
            
        case 'USER_MODEL_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.User_Model_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды USER_MODEL_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.User_Model_0 = temp_cell_array{2};
            
        case 'USER_MODEL_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.User_Model_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды USER_MODEL_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.User_Model_1 = temp_cell_array{2};
            
        case 'TRAPEZOID_XD_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Trapezoid_Xd_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды TRAPEZOID_XD_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Trapezoid_Xd_0 = temp_cell_array{2};
            
        case 'TRAPEZOID_XD_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Trapezoid_Xd_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды TRAPEZOID_XD_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Trapezoid_Xd_1 = temp_cell_array{2};
            
        case 'MODEL_X_P2_P1_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p2_p1_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P2_P1_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p2_p1_0 = temp_cell_array{2};
            
        case 'MODEL_X_P2_P1_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p2_p1_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P2_P1_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p2_p1_1 = temp_cell_array{2};
            
        case 'MODEL_X_P3_P1_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p3_p1_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P3_P1_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p3_p1_0 = temp_cell_array{2};
            
        case 'MODEL_X_P3_P1_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p3_p1_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P3_P1_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p3_p1_1 = temp_cell_array{2};
            
        case 'MODEL_X_P4_P1_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p4_p1_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P4_P1_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p4_p1_0 = temp_cell_array{2};
            
        case 'MODEL_X_P4_P1_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_p4_p1_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_P4_P1_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_p4_p1_1 = temp_cell_array{2};
            
        case 'MODEL_X_F_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f_0 = temp_cell_array{2};
            
        case 'MODEL_X_F_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f_1 = temp_cell_array{2};
            
        case 'MODEL_X_F1_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f1_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F1_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f1_0 = temp_cell_array{2};
            
        case 'MODEL_X_F1_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f1_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F1_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f1_1 = temp_cell_array{2};
            
        case 'MODEL_X_F2_EXTRAP_0'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f2_0))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F2_EXTRAP_0 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f2_0 = temp_cell_array{2};
            
        case 'MODEL_X_F2_EXTRAP_1'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Extrapolation.Model_X_f2_1))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды MODEL_X_F2_EXTRAP_1 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Extrapolation.Model_X_f2_1 = temp_cell_array{2};
            
        case 'SUMMATION_POINT'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Summation_Point))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды SUMMATION_POINT !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Summation_Point = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'COORD_ORIGIN'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Coord_Origin))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды COORD_ORIGIN !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Coord_Origin = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'POINT_ON_AXIS_3'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Point_On_Axis_3))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды POINT_ON_AXIS_3 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Point_On_Axis_3 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'POINT_ON_PLANE_13'
            
            N_Data_Items = 3;
            
            if (~isempty(Load.Point_On_Plane_13))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды POINT_ON_PLANE_13 !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Point_On_Plane_13 = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'CORRECTION_COEFFICIENT'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Correction_Coefficient))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды CORRECTION_COEFFICIENT !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Correction_Coefficient = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'DISTRIBUTED_LOAD_MODE'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Distributed_Load_Mode))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды DISTRIBUTED_LOAD_MODE !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Distributed_Load_Mode = temp_cell_array{2};
            
        case 'VECTOR_FIELD_COMPONENT'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Vector_Field_Component))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды VECTOR_FIELD_COMPONENT !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Vector_Field_Component = Read_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
        case 'FIELD_NAME'
            
            N_Data_Items = 1;
            
            if (~isempty(Load.Field_Name))
                fprintf (1, '\nОшибка: в конфигурационном файле содержится более одной команды FIELD_NAME !\n');
                ErrCode = -1;
                fclose(Fin);
                return;
            end
            
            Check_Cell_Array(temp_cell_array, string, N_Data_Items);
            
            if (ErrCode < 0)
                fclose(Fin);
                return;
            end
            
            Load.Field_Name = temp_cell_array{2};
            
        otherwise
            
            fprintf (1, '\nОшибка: нарушен формат конфигурационного файла в строке [%s] !\n', string);
            ErrCode = -1;
            fclose(Fin);
            return;
        
    end
    
end

% Закрытие файла
fclose(Fin);

% Проверка наличия необходимых настроек

if (isempty(Load.Basic_Plane.Definition))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр BASIC_PLANE_DEFINITION !\n');
    return;
end

if (isempty(Load.Basic_Plane.Z0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр Z0 !\n');
    return;
end

if (isempty(Load.Basic_Plane.Z1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр Z1 !\n');
    return;
end

if (isempty(Load.Basic_Plane.D1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр D1 !\n');
    return;
end

if (isempty(Load.Basic_Plane.D2))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр D2 !\n');
    return;
end

if (isempty(Load.Basic_Plane.D3))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр D3 !\n');
    return;
end

if (isempty(Load.Chord_Surface.A1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр A1 !\n');
    return;
end

if (isempty(Load.Chord_Surface.A2))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр A2 !\n');
    return;
end

if (isempty(Load.Chord_Surface.A3))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр A3 !\n');
    return;
end

if (isempty(Load.Chord_Surface.A4))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр A4 !\n');
    return;
end

if (isempty(Load.Pn))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр PN !\n');
    return;
end

if (isempty(Load.Span_Load.Law))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_LOAD_LAW !\n');
    return;
end

if (isempty(Load.Span_Load.Trapezoid_Zd_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_TRAPEZOID_ZD_TYPE !\n');
    return;
end

if (isempty(Load.Span_Load.Trapezoid_Zd_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_TRAPEZOID_ZD_VALUE !\n');
    return;
end

if (isempty(Load.Span_Load.Trapezoid_Zd_Location))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_TRAPEZOID_ZD_LOCATION !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Law))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_PRESSURE_LAW !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Trapezoid_Xd_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_TRAPEZOID_XD_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Trapezoid_Xd_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_TRAPEZOID_XD_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Trapezoid_Xd_Location))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_TRAPEZOID_XD_LOCATION !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p2_p1_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P2_P1_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p2_p1_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P2_P1_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p3_p1_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P3_P1_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p3_p1_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P3_P1_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p4_p1_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P4_P1_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_p4_p1_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_P4_P1_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f1_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F1_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f1_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F1_VALUE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f2_Type))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F2_TYPE !\n');
    return;
end

if (isempty(Load.Chord_Pressure.Model_X_f2_Value))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_MODEL_X_F2_VALUE !\n');
    return;
end

if (isempty(Load.Extrapolation.Span_Load_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_LOAD_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Span_Load_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SPAN_LOAD_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Chord_Pressure_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_PRESSURE_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Chord_Pressure_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CHORD_PRESSURE_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.User_Model_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр USER_MODEL_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.User_Model_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр USER_MODEL_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Trapezoid_Xd_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр TRAPEZOID_XD_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Trapezoid_Xd_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр TRAPEZOID_XD_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p2_p1_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P2_P1_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p2_p1_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P2_P1_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p3_p1_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P3_P1_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p3_p1_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P3_P1_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p4_p1_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P4_P1_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_p4_p1_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_P4_P1_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f1_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F1_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f1_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F1_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f2_0))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F2_EXTRAP_0 !\n');
    return;
end

if (isempty(Load.Extrapolation.Model_X_f2_1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр MODEL_X_F2_EXTRAP_1 !\n');
    return;
end

if (isempty(Load.Summation_Point))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр SUMMATION_POINT !\n');
    return;
end

if (isempty(Load.Coord_Origin))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр COORD_ORIGIN !\n');
    return;
end

if (isempty(Load.Point_On_Axis_3))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр POINT_ON_AXIS_3 !\n');
    return;
end

if (isempty(Load.Point_On_Plane_13))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр POINT_ON_PLANE_13 !\n');
    return;
end

if (isempty(Load.Correction_Coefficient))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр CORRECTION_COEFFICIENT !\n');
    return;
end

if (isempty(Load.Distributed_Load_Mode))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр DISTRIBUTED_LOAD_MODE !\n');
    return;
end

if (isempty(Load.Vector_Field_Component))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр VECTOR_FIELD_COMPONENT !\n');
    return;
end

if (isempty(Load.Field_Name))
    ErrCode = -1;
    fprintf (1, '\nОшибка: в конфигурационном файле отсутствует параметр FIELD_NAME !\n');
    return;
end
